unit LstFile;

interface
uses
  Classes, SysUtils, Misc;

type TListFile = class(TObject)
  private
    ListStrings: TStringList;
  public
    constructor Create(FName: string); overload;
    destructor Destroy;
    function GetKeyValue(SName, Key : string) : string;
    function GetSection(SName : string) : TStringList;
    procedure Check(var stat: boolean);
  published
    constructor Create(Stream: TStream); overload;
  end;


implementation

constructor TListFile.Create(FName: string);
begin
  inherited Create;
  ListStrings:=TStringList.Create;
  ListStrings.LoadFromFile(FName);
end;

constructor TListFile.Create(Stream: TStream);
begin
  inherited Create;
  ListStrings:=TStringList.Create;
  ListStrings.LoadFromStream(Stream);
end;

function TListFile.GetSection(SName : string) : TStringList;
var
  TS : string;
  i  : integer;
begin
  Result:=TStringList.Create;
  i:=0;
  while i<ListStrings.Count do
  begin
    TS:=Trim(ListStrings[i]);
    if (TS = '['+SName+']') then
    begin
      repeat
        inc(i);
        TS:=Trim(ListStrings[i]);
        if(TS<>'') then Result.Add(TS);
      until (TS='[/'+SName+']') or (i = ListStrings.Count);
      if(Result.Count>0) then Result.Delete(Result.Count-1);
      Break;
    end;
   inc(i);
  end; // end of while
  if(Result.Count=0) then Result.Add('FAIL');
end;

function TListFile.GetKeyValue(SName, Key : string) : string;
var
  TS : string;
  Params : TStringList;
  i: integer;
begin
  Result:='';
  Params:=TStringList.Create;
  i:=0;
  if ListStrings.Count=0 then exit;
  while i<ListStrings.Count do
  begin
    TS:=Trim(ListStrings[i]);
    if (TS = '['+SName+']') then
    begin
      repeat
        inc(i);
        TS:=Trim(ListStrings[i]);
        if(TS<>'') then
        begin
          Params:=Tokenize(TS,'|');
          if(Params[Params.Count-1]=Key) then
          begin
            Result:=Params[0];
            break;
          end;
        end
        else Result:='9999';
      until (TS='[/'+SName+']')  or (i = ListStrings.Count);
      Break;
    end;
    inc(i);
  end; //end of while
end;



destructor TListFile.Destroy;
begin
  inherited Destroy;
  ListStrings.Free;
end;

procedure TListFile.Check(var stat: boolean);
begin
  If ListStrings.Count = 0 then stat := false
  else stat:= true;

end;

end.

