unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, OleCtrls, SHDocVw, ShlObj, ComObj, ExtCtrls, StdCtrls, Gauges,
  ImgBtn, Registry, ActiveX;

const
  UPD_MESSAGE = WM_USER + 1;
  UPD_PROGRESS_MAX = WM_USER + 2;
  UPD_PROGRESS = WM_USER + 3;
  UPD_LOCK_FORM = WM_USER + 4;
  UPD_UPDATE_SET = WM_USER + 5;

type
  TForm1 = class(TForm)
    btnClose: TImgBtn;
    btnSettings: TImgBtn;
    btnStart: TImgBtn;
    btnFullCheck: TImgBtn;
    btnCancel: TImgBtn;
    Image1: TImage;
    prgFull: TGauge;
    prgFile: TGauge;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    wbPanel: TPanel;
    WebBrowser1: TWebBrowser;
    statLabel: TLabel;
    Timer1: TTimer;
    procedure FormCreate(Sender: TObject);
    procedure btnCloseClick(Sender: TObject);
    procedure btnCancelClick(Sender: TObject);

    procedure FormMouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure FormMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure FormMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure btnStartClick(Sender: TObject);
    procedure SetProgressMax(var msg: TMessage); message UPD_PROGRESS_MAX;
    procedure UpdateProgress(var msg: TMessage); message UPD_PROGRESS;
    procedure UpdateStatus(var msg: TMessage); message UPD_MESSAGE;
    procedure LockForm(var msg: TMessage); message UPD_LOCK_FORM;
    procedure UpdateSettings(var msg: TMessage); message UPD_UPDATE_SET;
    procedure WebBrowser1NavigateComplete2(Sender: TObject;
      const pDisp: IDispatch; var URL: OleVariant);
    procedure Timer1Timer(Sender: TObject);
    procedure btnSettingsClick(Sender: TObject);
    procedure btnFullCheckClick(Sender: TObject);

  private
    { Private declarations }
  public
    { Public declarations }
   settings_changed, bakFlag,  Revision, SelectedMirror: integer;
   URLS, tags: TStringList;
  end;

var
  Form1: TForm1;
  Draging: boolean;
  X0,Y0: integer;

implementation

{$R *.dfm}

uses
 Lstfile,  datfile, BZip2, Unit2, Unit3, GetFilesThr, Misc;

var
 l3s_path, ExeName, ExePath: string;
 Settings,Mirrors: TStringList;
 link_flag: integer;



procedure LoadSettings;
var
 TempList: TListFile;
 z: TMemoryStream;
 RegEntry: TRegIniFile;
begin
 z:=TMemoryStream.Create;
 RegEntry:= TRegIniFile.Create('Software');
 RegEntry.OpenKey(ChangeFileExt(ExtractFileName(Application.ExeName),''),true);
 try
  LoadFromEnd(l3s_path,z);
 except
  Application.Terminate;
 end;
 TempList:=TListFile.Create(z);
 Settings.Add(TempList.GetKeyValue('settings','NewsUrl'));
 Settings.Add(TempList.GetKeyValue('settings','LinkName'));
 Settings.Add(TempList.GetKeyValue('settings','RunCustom'));
 Settings.Add(RegEntry.ReadString('','Installed','false'));
 Settings.Add(RegEntry.ReadString('','SelectedMirrorId','-1'));
 Settings.Add(RegEntry.ReadString('','CreateBackup','0'));
 Settings.Add(RegEntry.ReadString('','CurrentRevision','0'));
 Form1.SelectedMirror:=StrToInt(Settings[4]);
 Form1.bakFlag:=StrToInt(Settings[5]);
 Form1.Revision:=StrToInt(Settings[6]);
 Mirrors:=TempList.GetSection('updates_mirrors');
 z.Free;
 TempList.Free;
 RegEntry.Free;
end;

procedure SaveSettings;
var
 RegEntry: TRegIniFile;
begin
 RegEntry:= TRegIniFile.Create('Software');
 RegEntry.OpenKey(ChangeFileExt(ExtractFileName(Application.ExeName),''),true);
 RegEntry.WriteString('','Installed',Settings[3]);
 RegEntry.WriteString('','SelectedMirrorId',IntToStr(Form1.SelectedMirror));
 RegEntry.WriteString('','CurrentRevision',IntToStr(Form1.Revision));
 RegEntry.WriteString('','CreateBackup', IntToStr(Form1.bakFlag));
 RegEntry.Free;
end;

procedure LoadBtnParam(list: TListFile; Btn: TImgBtn; btnname, path: string);
var
 m: TMemoryStream;
 pic: TPicture;
 tmpBool : boolean;
 tmpStr : string;
begin
  tmpStr:=list.GetKeyValue('buttons','btn_'+btnname+'_visible');
  if tmpStr<>'' then tmpBool:=StrToBool(tmpStr)
  else tmpBool:=true;
  Btn.Visible:= tmpBool;
  if not tmpBool then exit;
  m:=TMemoryStream.Create;
  pic:=TPicture.Create;
  Load(path,btnname+'_normal.bmp',m);
  pic.Bitmap.LoadFromStream(m);
  Btn.Pic.Bitmap.LoadFromStream(m);
  Btn.SetPic(pic);
  pic.Free;
  m.Clear;
  Load(path,btnname+'_hover.bmp',m);
  Btn.PicUp.Bitmap.LoadFromStream(m);
  m.Clear;
  Load(path,btnname+'_pressed.bmp',m);
  Btn.PicDown.Bitmap.LoadFromStream(m);
  m.Clear;
  m.Free;
  Btn.Top:= StrToInt(list.GetKeyValue('buttons','btn_'+btnname+'_top'));
  Btn.Left:= StrToInt(list.GetKeyValue('buttons','btn_'+btnname+'_left'));
  Btn.Width:= StrToInt(list.GetKeyValue('buttons','btn_'+btnname+'_width'));
  Btn.Height:= StrToInt(list.GetKeyValue('buttons','btn_'+btnname+'_height'));
end;

procedure LoadProgressParam(list: TListFile; Pr: TGauge; name: string);
begin
  Pr.Top:=StrToInt(list.GetKeyValue('progress',name+'_top'));
  Pr.Left:=StrToInt(list.GetKeyValue('progress',name+'_left'));
  Pr.Width:=StrToInt(list.GetKeyValue('progress',name+'_width'));
  Pr.Height:=StrToInt(list.GetKeyValue('progress',name+'_height'));
  Pr.BackColor:=StringToColor(list.GetKeyValue('progress',name+'_bg'));
  Pr.ForeColor:=StringToColor(list.GetKeyValue('progress',name+'_fg'));
end;

procedure LoadLabelParam(list: TListFile; Lb: TLabel; name: string);
begin
  Lb.Top:=StrToInt(list.GetKeyValue('labels',name+'_top'));
  Lb.Left:=StrToInt(list.GetKeyValue('labels',name+'_left'));
  Lb.Caption:= list.GetKeyValue('labels',name+'_text');
  Lb.Font.Color:=StringToColor(list.GetKeyValue('labels',name+'_font_color'));
  Lb.Font.Name:=list.GetKeyValue('labels',name+'_font_name');
  Lb.Font.Size:=StrToInt(list.GetKeyValue('labels',name+'_font_size'));
  Lb.Visible:=StrToBool(list.GetKeyValue('labels',name+'_visible'));
end;



procedure LoadSkin(path: string);
var
 m: TMemoryStream;
 f: TFileStream;
 list: TListFile;
 temp: boolean;
begin
  temp:=true;
  m:=TMemoryStream.Create;
  load(path,'skinparam',m);
  list:=TListFile.Create(m);
  list.Check(temp);
  if Temp then
  begin
    m.Clear;
    Form1.ClientWidth:=StrToInt(list.GetKeyValue('main_frm','frm_width'));
    Form1.ClientHeight:=StrToInt(list.GetKeyValue('main_frm','frm_height'));
    link_flag:=StrToInt(list.GetKeyValue('etc','use_custom_ico'));
    if (link_flag = 1) and not(FileExists(ExeName+'.ico')) then
    begin
      f:=TFileStream.Create(ExeName+'.ico',fmCreate or fmOpenWrite);
      Load(path,'updater.ico',m);
      f.CopyFrom(m,m.Size);
      m.Clear;
      f.Free;
    end;
    load(path,'fr_back.bmp',m);
    Form1.Image1.Picture.Bitmap.LoadFromStream(m);
    m.Clear;
    LoadBtnParam(list ,Form1.btnClose,'cl',path);
    LoadBtnParam(list ,Form1.btnSettings,'se',path);
    LoadBtnParam(list ,Form1.btnStart,'st',path);
    LoadBtnParam(list ,Form1.btnCancel,'ca',path);
    LoadBtnParam(list ,Form1.btnFullCheck,'fu',path);
    LoadProgressParam(list, Form1.prgFile, 'file_progress');
    LoadProgressParam(list, Form1.prgFull, 'total_progress');
    m.Free;
    Form1.wbPanel.Top:=StrToInt(list.GetKeyValue('browser','br_top'));
    Form1.wbPanel.Left:=StrToInt(list.GetKeyValue('browser','br_left'));
    Form1.wbPanel.Height:=StrToInt(list.GetKeyValue('browser','br_height'));
    Form1.wbPanel.Width:=StrToInt(list.GetKeyValue('browser','br_width'));
    LoadLabelParam(list, Form1.Label1, 'label1');
    LoadLabelParam(list, Form1.Label2, 'label2');
    LoadLabelParam(list, Form1.Label3, 'label3');
    LoadLabelParam(list, Form1.statLabel, 'stat_label');
    Form1.statLabel.Width:=StrToInt(list.GetKeyValue('labels','stat_label_width'));
    list.Free;
  end
  else Application.Terminate;
end;



procedure CreateDesktopIcon(ilname, WorkDir, desc, iPath : string);
var
  IObj : IUnknown;
  SLink : IShellLink;
  PFile : IPersistFile;
  desk : string;
  lnkpath : WideString;
begin
  if(ilname<>'') then begin
  SetLength(desk, MAX_PATH+1);
  SHGetSpecialFolderPath(0, PAnsiChar(desk),CSIDL_DESKTOPDIRECTORY,False);
  lnkpath:= PChar(desk)+'\'+ilname+'.lnk';
  IObj := CreateComObject(CLSID_ShellLink);
  SLink := IObj as IShellLink;
  PFile := IObj as IPersistFile;
  with SLink do
  begin
    SetDescription(PChar(desc));
    SetPath(PChar(Application.ExeName));
    SetWorkingDirectory(PAnsiChar(WorkDir));
    if link_flag = 1 then
      SetIconLocation(PAnsiChar(iPath),0);
  end;
  PFile.Save(PWChar(WideString(lnkpath)), FALSE);
  end;
end;

procedure TForm1.FormCreate(Sender: TObject);
var
 nullClr: TColor;
 regn, tmpRegn, x, y, i: integer;
 List : TStringList;
begin
  //     \    
  ExePath:=ExtractFilePath(Application.ExeName);
  ExeName:=ExePath+ChangeFileExt(ExtractFileName(Application.ExeName),'');
  l3s_path:=ExeName+'.l3s';
  LoadSkin(l3s_path);

  //     :)
  Form1.brush.bitmap:=Image1.picture.bitmap;
  nullClr := image1.picture.Bitmap.Canvas.Pixels[0, 0];
  regn := CreateRectRgn(0, 0, image1.picture.Graphic.Width,
  image1.picture.Graphic.Height);
  for x := 1 to image1.picture.Graphic.Width do
    for y := 1 to image1.picture.Graphic.Height do
      if image1.picture.Bitmap.Canvas.Pixels[x - 1, y - 1] = nullClr then
      begin
        tmpRegn := CreateRectRgn(x - 1, y - 1, x, y);
        CombineRgn(regn, regn, tmpRegn, RGN_DIFF);
        DeleteObject(tmpRegn);
      end;
  SetWindowRgn(Form1.handle, regn, true);

  //  
  Settings:=TStringLIst.Create;
  Mirrors:=TStringLIst.Create;
  LoadSettings;
  if (Settings[3]='false') and (Settings[1]<>'none')  then
  begin
    CreateDesktopIcon(Settings[1],ExePath,Settings[1],ExeName+'.ico');
    Settings[3]:='true';
    settings_changed:=1;
  end;
  List:=TStringList.Create;
  URLS:=TStringList.Create;
  tags:=TStringList.Create;
  for i:=0 to Mirrors.Count-1 do
   begin
    List:=Tokenize(Mirrors[i],'|');
    URLS.Add(List[1]);
    tags.Add(List[0]);
  end;
  List.Free;
  i:=StrToInt(Settings[4]);
  if(i < 0) or (URLS.Count-1 < i ) then begin
   if URLS.Count > 1 then begin
     form2 := TForm2.Create(self);
     if Form2.ShowModal = mrOk then i:=Form2.ListBox1.ItemIndex;
     form2.free;
   end
   else if URLS.Count = 0 then Exit
   else
     i:=0;
   settings_changed:=1;
   Settings[4]:=IntToStr(i);
   Form1.SelectedMirror:=i;
  end;
  Timer1.Enabled:=True;
end;

procedure TForm1.btnCloseClick(Sender: TObject);
begin
 Close();
end;

procedure TForm1.btnCancelClick(Sender: TObject);
begin
 Close();
end;


procedure TForm1.FormMouseMove(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);
begin
  if Draging = true then
  begin
    Form1.Left := Form1.Left + X - X0;
    Form1.top := Form1.top + Y - Y0;
  end;
end;

procedure TForm1.FormMouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
 Draging:=False;
end;

procedure TForm1.FormMouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
 Draging:=true;
 x0:=X;
 y0:=Y;
end;

procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
begin
 if settings_changed = 1 then SaveSettings;
 if (FileExists(ExePath+'\files.lst')) then
   DeleteFile('files.lst');
 Settings.Free;
 Mirrors.Free;
 tags.Free;
end;

procedure TForm1.btnStartClick(Sender: TObject);
begin
 if(FileExists(ExePath+'\'+settings[2])) then
 begin
   Form1.Hide;
   RunApp(ExePath+'\'+settings[2]);
   close();
 end;
end;

procedure TForm1.WebBrowser1NavigateComplete2(Sender: TObject;
  const pDisp: IDispatch; var URL: OleVariant);
begin
  WebBrowser1.Width:=wbPanel.Width+4;
  WebBrowser1.Height:=wbPanel.Height+4;
  WbPanel.Visible:=True;
end;

procedure TForm1.SetProgressMax(var msg: TMessage);
begin
 case msg.WParam of
  0: begin
      Form1.prgFile.Progress:=0;
      Form1.prgFile.MaxValue:=msg.LParam;
     end;
  1: begin
      Form1.prgFull.Progress:=0;
      Form1.prgFull.MaxValue:=msg.LParam;
     end;
 end;
 msg.Result:=1;
end;

procedure TForm1.LockForm(var msg: TMessage);
var
 i: integer;
begin
 if (msg.LParam = 0 ) then
  begin
   Form1.btnSettings.Visible:=false;
   Form1.btnStart.Visible:=false;
   Form1.btnFullCheck.Visible:=false;
  end
 else
  begin
   Form1.btnSettings.Visible:=true;
   Form1.btnStart.Visible:=true;
   Form1.btnFullCheck.Visible:=true;
 end;
 msg.Result:=1;
end;

procedure TForm1.UpdateProgress(var msg: TMessage);
begin
 case msg.WParam of
  0: Form1.prgFile.Progress:=msg.LParam;
  1: Form1.prgFull.Progress:=msg.LParam;
 end;
 msg.Result:=1;
end;

procedure TForm1.UpdateStatus(var msg: TMessage);
var
  text: string;
begin
  text:=PChar(msg.LParam);
  msg.Result:=1;
  Form1.statLabel.Caption:=text;
end;


procedure TForm1.Timer1Timer(Sender: TObject);
var
  WThread : GFilesThread;
begin
  Form1.Timer1.Enabled:=False;
  WebBrowser1.Navigate(Settings[0]);
  StatLabel.Caption:='';
  WThread:=GFilesThread.Create(True);
  WThread.FreeOnTerminate:=True;
  WThread.UpdatesUrl:=URLS[StrToInt(Settings[4])];
  WThread.ForceCheck:=False;
  WThread.CreateBackup:=StrToInt(Settings[5]);
  WThread.LocalRevision:=StrToInt(Settings[6]);
  if (Paramcount>0) then
   begin
    if (DirectoryExists(ParamStr(1))) then
    begin
     if ParamStr(1)[length(ParamStr(1))]<>'\' then WThread.WorkDir:=ParamStr(1)+'\'
     else WThread.WorkDir:=ParamStr(1);
    end
    else
     WThread.WorkDir:=ExePath;
   end
  else
    WThread.WorkDir:=ExePath;
  WThread.Resume;
end;

procedure TForm1.UpdateSettings(var msg: TMessage);
begin
 Settings[6]:=IntToStr(msg.LParam);
 settings_changed:=1;
end;

procedure TForm1.btnSettingsClick(Sender: TObject);
var mr : integer;
begin
   Form3.ComboBox1.Items:=Form1.tags;
   form3.MirrorId:= SelectedMirror;
   Form3.BackFlag:= bakFlag;
   mr:=Form3.ShowModal;
   if mr=mrOk then settings_changed:=1;
end;

procedure TForm1.btnFullCheckClick(Sender: TObject);
var
  WThread : GFilesThread;
begin
  Form1.Timer1.Enabled:=False;
  WebBrowser1.Navigate(Settings[0]);
  StatLabel.Caption:='';
  WThread:=GFilesThread.Create(True);
  WThread.FreeOnTerminate:=True;
  WThread.UpdatesUrl:=URLS[SelectedMirror];
  WThread.ForceCheck:=True;
  WThread.CreateBackup:=BakFlag;
  WThread.LocalRevision:=StrToInt(Settings[6]);
  if (Paramcount>0) then
   begin
    if (DirectoryExists(ParamStr(1))) then
    begin
     if ParamStr(1)[length(ParamStr(1))]<>'\' then WThread.WorkDir:=ParamStr(1)+'\'
     else WThread.WorkDir:=ParamStr(1);
    end
    else
     WThread.WorkDir:=ExePath;
   end
  else
    WThread.WorkDir:=ExePath;
  WThread.Resume;
end;

end.
